
Fortschritt = {};

function Fortschritt.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Combine, specializations);
end;

function Fortschritt:load(xmlFile)
    hornSoundFile = Utils.getFilename("superHorn.wav", self.baseDirectory);
    self.hornSoundId = createSample("LizardHornSound");
    loadSample(self.hornSoundId, hornSoundFile, false);
    self.hornPlaying = false;
    local attachNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.attach#index"));
    if attachNode ~= nil then
        self.attach = {};
        self.attach.node = attachNode;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.attach#minRot"));
        self.attach.minRot = {};
        self.attach.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.attach.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.attach.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.attach#maxRot"));
        self.attach.maxRot = {};
        self.attach.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.attach.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.attach.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.attach.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.attach#rotTime"), 2)*1000;
        self.attach.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.attach#touchRotLimit"), 10));
    end;
	self.internalCamera = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.internalCamera#index"));
	if self.camPositionX == nil then
		self.camPositionX = 0;
	end;

	if self.camPositionZ == nil then
		self.camPositionZ = 0;
	end;
end;
function Fortschritt:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)
	self.camPositionX = Utils.getNoNil(getXMLFloat(xmlFile, key.."#camPositionX"), 0);
	self.camPositionZ = Utils.getNoNil(getXMLFloat(xmlFile, key.."#camPositionZ"), 0);

	end;
function Fortschritt:delete()
    delete(self.burnerSoundId);
end;



function Fortschritt:getSaveAttributesAndNodes(nodeIdent)

end;


function Fortschritt:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Fortschritt:keyEvent(unicode, sym, modifier, isDown)
if isDown and sym == Input.KEY_KP_0 then
		self.helpPanel = not self.helpPanel;
	end;
	if sym == Input.KEY_pagedown then
		self.attachMax = isDown;
	end;
	if sym == Input.KEY_pageup then
		self.attachMin = isDown;
	end;
end;

function Fortschritt:update(dt)
if self.isEntered then
		if InputBinding.isPressed(InputBinding.COMBINEMOVECAMLEFT) then
				self.camPositionX = self.camPositionX + 0.02;
				if self.camPositionX >= 0.4 then
					self.camPositionX = 0.4;
				end;


		end;

		if InputBinding.isPressed(InputBinding.COMBINEMOVECAMRIGHT) then
				self.camPositionX = self.camPositionX - 0.02;
				if self.camPositionX <= -0.4 then
					self.camPositionX = -0.4;
				end;

		end;

		if InputBinding.isPressed(InputBinding.COMBINEMOVECAMFORWARD) then
				self.camPositionZ = self.camPositionZ + 0.02;
				if self.camPositionZ >= 0.3 then
					self.camPositionZ = 0.3;
				end;

		end;

		if InputBinding.isPressed(InputBinding.COMBINEMOVECAMBACK) then
				self.camPositionZ = self.camPositionZ - 0.02;
				if self.camPositionZ <= -0.3 then
					self.camPositionZ = -0.3;
				end;

		end;

		if InputBinding.hasEvent(InputBinding.COMBINEMOVECAMRESET) then
				self.camPositionX = 0;
				self.camPositionZ = 0;
			end;
		end;

if self:getIsActiveForInput() and self:getIsActiveForSound() and InputBinding.isPressed(InputBinding.LIZARD2000_SILLYHORN) then
        if not self.hornPlaying then
            playSample(self.hornSoundId, 0, 1, 0);
            self.hornPlaying = true;
        end;
    else
        if self.hornPlaying then
            stopSample(self.hornSoundId);
            self.hornPlaying = false;
        end;
    end;
	local doRotate = self.attachMax or self.attachMin
	if self.attach ~= nil and doRotate then
        	local x, y, z = getRotation(self.attach.node);
        	local rot = {x,y,z};
        	local newRot = Utils.getMovedLimitedValues(rot, self.attach.maxRot, self.attach.minRot, 3, self.attach.rotTime, dt, not self.attachMax);
        	setRotation(self.attach.node, unpack(newRot));
	end;
	if self.internalCamera ~= nil then
		setTranslation(self.internalCamera, self.camPositionX, 0, self.camPositionZ);
	end;
end;

function Fortschritt:draw()

end;

function Fortschritt:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

function Fortschritt:openPipe()
end;


